package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("AuthorityEntry")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AuthorityEntry implements Marshallable {
	private Url url;
	private boolean disabled;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public AuthorityEntry url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public AuthorityEntry url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public boolean getDisabled() {
	    return disabled;
	}
	public void setDisabled(final boolean value) {
	    this.disabled = value;
	}

	public AuthorityEntry disabled(final boolean value) {
	    setDisabled(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.url == null)) {
            marshaller.writeUrl(1, this.url);
        }
        if (!(!this.disabled)) {
            marshaller.writeBool(2, this.disabled);
        }
        return marshaller.array();
    }
}
